#version 430 core
layout(location = 0) in vec3 position;
layout(location = 1) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;

void main() {
	vert.uv = uv;
	vec4 position_world_ = modelMatrix * vec4(position, 1);
	vert.position_world = position_world_.xyz;
	mat4 modelView = viewMatrix * modelMatrix;
	modelView[0][0] = 1;
	modelView[0][1] = 0;
	modelView[0][2] = 0;
	modelView[1][0] = 0;
	modelView[1][1] = 1;
	modelView[1][2] = 0;
	modelView[2][0] = 0;
	modelView[2][1] = 0;
	modelView[2][2] = 1;
	gl_Position = projMatrix * modelView * vec4(position, 1);
}